unit CustomSLOGSnodeMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Controls, CustomSLOGSnodeVisual
  , StdCtrls, ExtCtrls; //! zu löschen

type
  TVisualNodes=class of TCustomSLOGSNodeVisual;

  { TCustomSLOGSNode }
  TCustomSLOGSNode=Class(TComponent)
    private
      FLeft,FTop,FHeight,FWidth:Integer;
      FVisible: boolean;
      FVisual:TCustomSLOGSNodeVisual;
      FParent: TWinControl;
      function GetHeight: Integer;
      function GetLeft: Integer;
      function GetTop: Integer;
      function GetWidth: Integer;
      procedure SetHeight(AValue: Integer);
      procedure Setleft(AValue: Integer);
      procedure SetParent(AValue: TWinControl);
      procedure SetTop(AValue: Integer);
      procedure Setvisible(AValue: boolean);
      procedure SetWidth(AValue: Integer);
    protected //in der Vererbung ersetzen:
      function VisualCorrespondingClass: TVisualNodes; virtual;
      property VisualComponent:TCustomSLOGSNodeVisual read FVisual write FVisual;
    public
      constructor Create(AOwner: TComponent); override;
    published
      property Left:Integer read GetLeft write Setleft;
      property Top:Integer read GetTop write SetTop;
      property Width: Integer read GetWidth write SetWidth;
      property Height:Integer read GetHeight write SetHeight;
      property Visible:boolean read FVisible write Setvisible;
      property Parent:TWinControl read FParent write SetParent;
  end;

implementation

{ TCustomSLOGSNode }

function TCustomSLOGSNode.VisualCorrespondingClass: TVisualNodes;
begin
  result:=TCustomSLOGSNodeVisual;
end;

procedure TCustomSLOGSNode.Setvisible(AValue: boolean);
begin
  FVisible:=AValue;
  if AValue then begin
    if not Assigned(VisualComponent) then begin
      VisualComponent:=VisualCorrespondingClass.Create(self);
      VisualComponent.Left:=FLeft;
      VisualComponent.Top:=FTop;
      VisualComponent.Height:=FHeight;
      VisualComponent.Width:=FWidth;
      VisualComponent.Parent:=FParent;
    end;
  end else begin
    if Assigned(FVisual) then begin
      FLeft:=FVisual.Left;
      FHeight:=FVisual.Height;
      FTop:=FVisual.Top;
      FWidth:=FVisual.Width;
      FreeAndNil(FVisual);
    end;
  end;
end;

procedure TCustomSLOGSNode.SetWidth(AValue: Integer);
begin
  FWidth:=AValue;
  if Assigned(FVisual) then FVisual.Width:=AValue;
end;

constructor TCustomSLOGSNode.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTop:=0;FWidth:=0;FHeight:=10;FLeft:=10;
end;

procedure TCustomSLOGSNode.SetParent(AValue: TWinControl);
begin
  if FParent=AValue then Exit;
  FParent:=AValue;
  if Assigned(FVisual) then FVisual.Parent:=AValue;
end;

procedure TCustomSLOGSNode.SetTop(AValue: Integer);
begin
  FTop:=AValue;
  if Assigned(FVisual) then FVisual.Top:=AValue;
end;

function TCustomSLOGSNode.GetHeight: Integer;
begin
  If Assigned(FVisual)
    then result:=FVisual.Height
    else result:=FHeight;
end;

function TCustomSLOGSNode.GetLeft: Integer;
begin
  If Assigned(FVisual)
    then result:=FVisual.Left
    else result:=FLeft;
end;

function TCustomSLOGSNode.GetTop: Integer;
begin
  If Assigned(FVisual)
    then result:=FVisual.Top
    else result:=FTop;
end;

function TCustomSLOGSNode.GetWidth: Integer;
begin
  If Assigned(FVisual)
    then result:=FVisual.Width
    else result:=FWidth;
end;

procedure TCustomSLOGSNode.SetHeight(AValue: Integer);
begin
  FHeight:=AValue;
  if Assigned(FVisual) then FVisual.Height:=AValue;
end;

procedure TCustomSLOGSNode.Setleft(AValue: Integer);
begin
  FLeft:=AValue;
  if Assigned(FVisual) then FVisual.Left:=AValue;
end;


end.

