unit VehicleSourceVisual;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Controls, Graphics, CustomSLOGSnodeVisual, StdCtrls, ExtCtrls;

type

  { TVehicleSourceVisual }

  TVehicleSourceVisual=class(TCustomSLOGSNodeVisual)
    protected
      function CorrespondingFormClass: TNodeOptForm; override;
      procedure NodeShape(APattern: TBitmap); override;
      procedure NodeDecor(ADecor: TBitmap); override;
    protected
    public
    published
  end;

implementation

{ TVehicleSourceVisual }
uses
  VehicleSourceMain
  ,VehicleSourceOptForm
  ;

function TVehicleSourceVisual.CorrespondingFormClass: TNodeOptForm;
begin
  Result:=TVehicleSourceOptForm;
end;

procedure TVehicleSourceVisual.NodeShape(APattern: TBitmap);
  var a,b:integer;
begin
  a:=Width; b:=height;
  APattern.Canvas.Ellipse(0,0,width,height*2);
end;

procedure TVehicleSourceVisual.NodeDecor(ADecor: TBitmap);
  var width2:integer;
      width3:integer;
      height4:integer;
begin
  width2:=width div 2;
  width3:=width div 3;
  height4:=height div 4;
  with ADecor.canvas do begin
    FillRect(0,0,self.Width, Self.Height);
    //Umrandung:
    Arc(pen.Width div 2, pen.width div 2 , Width-1-(pen.width div 2),Height*2-1-(pen.width div 2),0*16,180*16);
    Line(0,height-pen.width div 2, width, height-pen.width div 2);
    //Symbol:
    Arc(width3, height4, width3*2, height, 16*0, 16*180);
    line(width2,height4,  width2, height4*3); //senkrecht
    line(width3, height4*3, width3*2, height4*3); //waagrecht
  end;
end;






end.

